-------------------------------------------------------------------------------
-- ObjectPaint.ms
-- Paints using current selection as the brush.
-- By Simon Feltman [Kinetix]  simon.feltman@ktx.com
-- TODO: have option to align object with one another

-- Edited by Frank D, for random painting 
-- Edited by Antoine Pasquay, for undo; Fall Off; align  www.athanaze.com  athanaze@fr.st

-------------------------------------------------------------------------------
	global settmp
	settmp = #()
	global axe
	axe = (eulerangles -90 -90 0)
	
	
	rollout ObjectPaint "Paramtres"
	(
		spinner spn_spacing "Espacements :" range:[0, 99999, 20] align:#right
		spinner spn_falof "Attnuation :" range:[-75, 75, 0] align:#right
		group "Aligner sur"
		(
		radiobuttons axis  labels:#("X  ","Y  ","Z  ") default:1
		checkbox flip "Inverser"
		)
		checkbutton btn_paint "Peindre" width:116
		button cancel "Annuler Pinceau" width:116
		
				
		on ObjectPaint open do
		(
		)	
		
		on axis changed state do
		(
		case axis.state of
			(
			1: if flip.checked == true then axe = (eulerangles -90 -90 180) else axe = (eulerangles -90 -90 0)
			2: if flip.checked == true then axe = (eulerangles 90 0 0) else axe = (eulerangles -90 0 0)
			3: if flip.checked == true then axe = (eulerangles 0 180 90) else axe = (eulerangles 0 0 90)	
			)
		)

	
		tool ObjectPaint prompt:"Peindre en utilisant le(s) objet(s) slectionn(s) comme brosse"
		(
			local lastObject
	
			on mousePoint clickno do
			(
			undo "Peindre" on -- Added Antoine P
				(
					if selection[1] != undefined and clickno == 1 then
					(
						lastObject = copy selection[Random 1 selection.count] pos:worldPoint -- Added Frank D
						append settmp lastobject
					)
					else
					(
						btn_paint.state = off
						#stop
					)
				)
			)
	
			on mouseMove clickno do
			(
			undo "Peindre" on -- Added Antoine P
					(
					if clickno == 2 then
						(					
						local vec = worldPoint - lastObject.pos
						local distSquared = vec.x*vec.x + vec.y*vec.y + vec.z*vec.z
						if distSquared > (spn_spacing.value*spn_spacing.value) then
						(
							vec = Normalize vec
							lastObject = reference selection[Random 1 selection.count] pos:(vec * spn_spacing.value + lastObject.pos) \
							scale: (lastObject.scale*(100 - spn_falof.value)/100) \
							dir: vec
							in coordsys local rotate lastObject axe
							append settmp lastobject
							selectionsets ["Pinceau"] = settmp
						) 
					)
				)
			)
	
			on mouseAbort clickno do
				btn_paint.state = off
		)
	
		on btn_paint changed state do
			if state == on then 
			(
			StartTool ObjectPaint 
			settmp = #()
			)
			else 
			( 
			StopTool ObjectPaint  
			)
		on cancel pressed do
		(
		try (delete selectionsets ["Pinceau"] ) catch()
		try (deleteitem selectionsets "Pinceau") catch() 
		)
	)

ObjectPaintFloater = newRolloutFloater "Peindre objet" 200 230
addRollout ObjectPaint ObjectPaintFloater
